#include <cmath>

namespace Metrics{

	// Interface: pure abstract class to get distance
	//
	//  this is quite expensive (anytime we need to access to the virtual table)
	//
	class Distance{

	public:
		virtual double getDistance(double x[], double y[], unsigned int l) = 0;
	};

	//  
	// Euclidean distance
	class EuclideanDistance: Distance{
	
	public:
		EuclideanDistance(){};

		double getDistance(double x[], double y[], unsigned int l)
		{
			double sumXY2 = 0.0;
			for(unsigned int i = 0; i < l; i++) 
			{
				sumXY2 += pow(x[i] - y[i], 2);
			}
			return sqrt(sumXY2);
		};
	};
}
