#include <cmath>

namespace Metrics{

	//  
	// Euclidean distance
	class EuclideanDistance {
	
	protected:                     // this must be not directly accessible since we want to provide a rich set of distances	
		EuclideanDistance(){};

		double getDistance(double x[], double y[], unsigned int l)
		{
			double sumXY2 = 0.0;
			for(unsigned int i = 0; i < l; i++) 
			{
				sumXY2 += pow(x[i] - y[i], 2);
			}
			return sqrt(sumXY2);
		};
	};

	template
	<typename Distance_Policy>     // this allows to provide a static mechanism for pseudo-like inheritance, 
								   // which is optimal from a performance point of view.
	class Distance : Distance_Policy
	{
		using Distance_Policy::getDistance;

	public:
		double distance(double x[], double y[], unsigned int l)
		{
			return getDistance(x, y, l);
		};
	};
}
